Index: pjproject/trunk/pjmedia/include/pjmedia/rtcp.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/rtcp.h	(revision 121)
+++ pjproject/trunk/pjmedia/include/pjmedia/rtcp.h	(revision 121)
@@ -0,0 +1,192 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJMEDIA_RTCP_H__
+#define __PJMEDIA_RTCP_H__
+
+/**
+ * @file rtcp.h
+ * @brief RTCP implementation.
+ */
+
+#include <pj/types.h>
+#include <pjmedia/rtp.h>
+
+PJ_BEGIN_DECL
+
+
+/**
+ * @defgroup PJMED_RTCP RTCP
+ * @ingroup PJMEDIA
+ * @{
+ */
+
+/**
+ * RTCP sender report.
+ */
+struct pj_rtcp_sr
+{
+    pj_uint32_t	    ssrc;
+    pj_uint32_t	    ntp_sec;
+    pj_uint32_t	    ntp_frac;
+    pj_uint32_t	    rtp_ts;
+    pj_uint32_t	    sender_pcount;
+    pj_uint32_t	    sender_bcount;
+};
+
+typedef struct pj_rtcp_sr pj_rtcp_sr;
+
+/**
+ * RTCP receiver report.
+ */
+struct pj_rtcp_rr
+{
+    pj_uint32_t	    ssrc;
+#if defined(PJ_IS_BIG_ENDIAN) && PJ_IS_BIG_ENDIAN!=0
+    pj_uint32_t	    fract_lost:8;
+    pj_uint32_t	    total_lost_2:8;
+    pj_uint32_t	    total_lost_1:8;
+    pj_uint32_t	    total_lost_0:8;
+#else
+    pj_uint32_t	    fract_lost:8;
+    pj_uint32_t	    total_lost_0:8;
+    pj_uint32_t	    total_lost_1:8;
+    pj_uint32_t	    total_lost_2:8;
+#endif	
+    pj_uint32_t	    last_seq;
+    pj_uint32_t	    jitter;
+    pj_uint32_t	    lsr;
+    pj_uint32_t	    dlsr;
+};
+
+typedef struct pj_rtcp_rr pj_rtcp_rr;
+
+/**
+ * RTCP common header.
+ */
+struct pj_rtcp_common
+{
+#if defined(PJ_IS_BIG_ENDIAN) && PJ_IS_BIG_ENDIAN!=0
+    unsigned	    version:2;	/* packet type            */
+    unsigned	    p:1;	/* padding flag           */
+    unsigned	    count:5;	/* varies by payload type */
+    unsigned	    pt:8;	/* payload type           */
+#else
+    unsigned	    count:5;	/* varies by payload type */
+    unsigned	    p:1;	/* padding flag           */
+    unsigned	    version:2;	/* packet type            */
+    unsigned	    pt:8;	/* payload type           */
+#endif
+    pj_uint16_t	    length;	/* packet length          */
+};
+
+typedef struct pj_rtcp_common pj_rtcp_common;
+
+/**
+ * RTCP packet.
+ */
+struct pj_rtcp_pkt
+{
+    pj_rtcp_common  common;	
+    pj_rtcp_sr	    sr;
+    pj_rtcp_rr	    rr;		/* variable-length list */
+};
+
+typedef struct pj_rtcp_pkt pj_rtcp_pkt;
+
+/**
+ * NTP time representation.
+ */
+struct pj_rtcp_ntp_rec
+{
+    pj_uint32_t	    hi;
+    pj_uint32_t	    lo;
+};
+
+typedef struct pj_rtcp_ntp_rec pj_rtcp_ntp_rec;
+
+/**
+ * RTCP session.
+ */
+struct pj_rtcp_session
+{
+    pj_rtcp_pkt		rtcp_pkt;
+    
+    pj_rtp_seq_session	seq_ctrl;
+
+    pj_uint32_t		received;       /* packets received */
+    pj_uint32_t		expected_prior; /* packet expected at last interval */
+    pj_uint32_t		received_prior; /* packet received at last interval */
+    pj_int32_t		transit;        /* relative trans time for prev pkt */
+    pj_uint32_t		jitter;		/* estimated jitter */
+    
+    pj_rtcp_ntp_rec	rtcp_lsr;	/* NTP timestamp in last sender report received */
+    unsigned 		rtcp_lsr_time;  /* Time when last RTCP SR is received. */
+    unsigned 		peer_ssrc;	/* Peer SSRC */
+    
+};
+
+typedef struct pj_rtcp_session pj_rtcp_session;
+
+/**
+ * Init RTCP session.
+ * @param session The session
+ * @param ssrc The SSRC used in to identify the session.
+ */
+PJ_DECL(void) pj_rtcp_init( pj_rtcp_session *session, pj_uint32_t ssrc );
+
+/**
+ * Deinit RTCP session.
+ * @param session The session.
+ */
+PJ_DECL(void) pj_rtcp_fini( pj_rtcp_session *session);
+
+/**
+ * Call this function everytime an RTP packet is received to let the RTCP
+ * session do its internal calculations.
+ * @param session The session.
+ * @param seq The RTP packet sequence number, in host byte order.
+ * @param ts The RTP packet timestamp, in host byte order.
+ */
+PJ_DECL(void) pj_rtcp_rx_rtp( pj_rtcp_session *session, pj_uint16_t seq, pj_uint32_t ts );
+
+/**
+ * Call this function everytime an RTP packet is sent to let the RTCP session
+ * do its internal calculations.
+ * @param session The session.
+ * @param bytes_payload_size The payload size of the RTP packet (ie packet minus
+ *             RTP header).
+ */
+PJ_DECL(void) pj_rtcp_tx_rtp( pj_rtcp_session *session, pj_uint16_t bytes_payload_size );
+
+/**
+ * Build a RTCP SR/RR packet to be transmitted to remote RTP peer.
+ * @param session The session.
+ * @param rtcp_pkt [output] Upon return, it will contain pointer to the RTCP packet.
+ * @param len [output] Upon return, it will indicate the size of the RTCP packet.
+ */
+PJ_DECL(void) pj_rtcp_build_rtcp( pj_rtcp_session *session, pj_rtcp_pkt **rtcp_pkt, int *len );
+
+/**
+ * @}
+ */
+
+PJ_END_DECL
+
+
+#endif	/* __PJMEDIA_RTCP_H__ */
Index: pjproject/trunk/pjmedia/include/pjmedia/rtp.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/rtp.h	(revision 121)
+++ pjproject/trunk/pjmedia/include/pjmedia/rtp.h	(revision 121)
@@ -0,0 +1,256 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJMEDIA_RTP_H__
+#define __PJMEDIA_RTP_H__
+
+#include <pj/types.h>
+
+/**
+ * @file rtp.h
+ * @brief RTP implementation.
+ */
+
+PJ_BEGIN_DECL
+
+
+/**
+ * @defgroup PJMED_RTP RTP
+ * @ingroup PJMEDIA
+ * @{
+ *
+ * The RTP module is designed to be dependent only to PJLIB, it does not depend
+ * on any other parts of PJMEDIA library. The RTP module does not even depend
+ * on any transports (sockets), to promote even more use.
+ *
+ * An RTCP implementation is also separated from this module.
+ *
+ * The functions that are provided by this module:
+ *  - creating RTP header for each outgoing packet.
+ *  - decoding RTP packet into RTP header and payload.
+ *  - provide simple RTP session management (sequence number, etc.)
+ *
+ * The RTP module does not use any dynamic memory at all.
+ *
+ * \section P1 How to Use the RTP Module
+ * 
+ * First application must call #pj_rtp_session_init to initialize the RTP 
+ * session.
+ *
+ * When application wants to send RTP packet, it needs to call 
+ * #pj_rtp_encode_rtp to build the RTP header. Note that this WILL NOT build
+ * the complete RTP packet, but instead only the header. Application can
+ * then either concatenate the header with the payload, or send the two
+ * fragments (the header and the payload) using scatter-gather transport API
+ * (e.g. \a sendv()).
+ *
+ * When application receives an RTP packet, first it should call
+ * #pj_rtp_decode_rtp to decode RTP header and payload, then it should call
+ * #pj_rtp_session_update to check whether we can process the RTP payload,
+ * and to let the RTP session updates its internal status. The decode function
+ * is guaranteed to point the payload to the correct position regardless of
+ * any options present in the RTP packet.
+ *
+ */
+
+
+#ifdef _MSC_VER
+#  pragma warning ( disable : 4214 )
+#endif
+
+
+/**
+ * Error codes.
+ */
+enum pj_rtp_error_t
+{
+    PJ_RTP_ERR_RTP_PACKING,	    /**< Invalid RTP packet. */
+    PJ_RTP_ERR_INVALID_VERSION,	    /**< Invalid RTP version. */
+    PJ_RTP_ERR_INVALID_SSRC,	    /**< Invalid SSRC. */
+    PJ_RTP_ERR_INVALID_PT,	    /**< Invalid payload type. */
+    PJ_RTP_ERR_INVALID_PACKET,	    /**< Invalid packet. */
+    PJ_RTP_ERR_SESSION_RESTARTED,   /**< Session has just been restarted. */
+    PJ_RTP_ERR_SESSION_PROBATION,   /**< Session in probation. */
+    PJ_RTP_ERR_BAD_SEQUENCE,	    /**< Bad RTP sequence number. */
+};
+
+#pragma pack(1)
+/**
+ * RTP packet header.
+ */
+struct pj_rtp_hdr
+{
+#if defined(PJ_IS_BIG_ENDIAN) && (PJ_IS_BIG_ENDIAN!=0)
+    pj_uint16_t v:2;	/**< packet type/version	    */
+    pj_uint16_t p:1;	/**< padding flag		    */
+    pj_uint16_t x:1;	/**< extension flag	    */
+    pj_uint16_t cc:4;	/**< CSRC count		    */
+    pj_uint16_t m:1;	/**< marker bit		    */
+    pj_uint16_t pt:7;	/**< payload type		    */
+#else
+    pj_uint16_t cc:4;	/**< CSRC count		    */
+    pj_uint16_t x:1;	/**< header extension flag    */ 
+    pj_uint16_t p:1;	/**< padding flag		    */
+    pj_uint16_t v:2;	/**< packet type/version	    */
+    pj_uint16_t pt:7;	/**< payload type		    */
+    pj_uint16_t m:1;	/**< marker bit		    */
+#endif
+    pj_uint16_t seq;	/**< sequence number	    */
+    pj_uint32_t ts;	/**< timestamp		    */
+    pj_uint32_t ssrc;	/**< synchronization source   */
+};
+#pragma pack()
+
+typedef struct pj_rtp_hdr pj_rtp_hdr;
+
+/**
+ * RTP extendsion header.
+ */
+struct pj_rtp_ext_hdr
+{
+    pj_uint16_t	profile_data;
+    pj_uint16_t	length;
+};
+
+typedef struct pj_rtp_ext_hdr pj_rtp_ext_hdr;
+
+/**
+ * A generic sequence number management, used by both RTP and RTCP.
+ */
+struct pj_rtp_seq_session
+{
+    pj_uint16_t	    max_seq;	    /**< highest sequence number heard */
+    pj_uint32_t	    cycles;	    /**< shifted count of seq. number cycles */
+    pj_uint32_t	    base_seq;	    /**< base seq number */
+    pj_uint32_t	    bad_seq;        /**< last 'bad' seq number + 1 */
+    pj_uint32_t	    probation;      /**< sequ. packets till source is valid */
+};
+
+typedef struct pj_rtp_seq_session pj_rtp_seq_session;
+
+/**
+ * RTP session descriptor.
+ */
+struct pj_rtp_session
+{
+    pj_rtp_hdr		out_hdr;    /**< Saved header for outgoing packets. */
+    pj_rtp_seq_session	seq_ctrl;   /**< Sequence number management. */
+    pj_uint16_t	        out_pt;	    /**< Default outgoing payload type. */
+    pj_uint32_t	        out_extseq; /**< Outgoing extended sequence number. */
+    pj_uint32_t	        peer_ssrc;  /**< Peer SSRC. */
+    pj_uint32_t	        received;   /**< Number of received packets. */
+};
+
+typedef struct pj_rtp_session pj_rtp_session;
+
+/**
+ * \brief Initialize RTP session.
+ * This function will initialize the RTP session according to given parameters.
+ *
+ * @param ses		The session.
+ * @param default_pt	Default payload type.
+ * @param sender_ssrc	SSRC used for outgoing packets.
+ *
+ * @return zero if successfull.
+ */
+PJ_DECL(pj_status_t) pj_rtp_session_init( pj_rtp_session *ses,
+					  int default_pt, pj_uint32_t sender_ssrc );
+
+/**
+ * \brief Encode outgoing RTP packet header.
+ * Create the RTP header based on arguments and current state of the RTP
+ * session.
+ *
+ * @param ses		The session.
+ * @param pt		Payload type.
+ * @param m		Marker flag.
+ * @param payload_len	Payload length in bytes.
+ * @param ts_len	Timestamp length.
+ * @param rtphdr	Upon return will point to RTP packet header.
+ * @param hdrlen	Upon return will indicate the size of RTP packet header
+ *
+ * @return zero if successfull.
+ */
+PJ_DECL(pj_status_t) pj_rtp_encode_rtp( pj_rtp_session *ses, int pt, int m,
+				        int payload_len, int ts_len,
+					const void **rtphdr, int *hdrlen );
+
+/**
+ * \brief Decode an incoming RTP packet.
+ * This function will decode incoming packet into RTP header and payload.
+ * The decode function is guaranteed to point the payload to the correct 
+ * position regardless of any options present in the RTP packet.
+ *
+ * @param ses		The session.
+ * @param pkt		The received RTP packet.
+ * @param pkt_len	The length of the packet.
+ * @param hdr		Upon return will point to the location of the RTP header
+ *			inside the packet.
+ * @param payload	Upon return will point to the location of the
+ *			payload inside the packet.
+ * @param payloadlen	Upon return will indicate the size of the payload.
+ *
+ * @return zero if successfull.
+ */
+PJ_DECL(pj_status_t) pj_rtp_decode_rtp( pj_rtp_session *ses, 
+				        const void *pkt, int pkt_len,
+					const pj_rtp_hdr **hdr,
+					const void **payload,
+					unsigned *payloadlen);
+
+/**
+ * \brief Update RTP session with an incoming RTP packet. 
+ * Call this function everytime
+ * an RTP packet is received to check whether the packet can be received and to
+ * let the RTP session performs its internal calculations.
+ *
+ * @param ses	    The session.
+ * @param hdr	    The RTP header of the incoming packet.
+ *
+ * @return zero if the packet is valid and can be processed, otherwise will
+ *         return one of the error in #pj_rtp_error_t.
+ */
+PJ_DECL(pj_status_t) pj_rtp_session_update( pj_rtp_session *ses, 
+					    const pj_rtp_hdr *hdr);
+
+/** 
+* \brief Internal.
+ * Internal function for sequence control, shared by RTCP implementation. 
+ */
+void pj_rtp_seq_init(pj_rtp_seq_session *seq_ctrl, pj_uint16_t seq);
+
+/** 
+* \brief Internal.
+ * Internal function for sequence control, shared by RTCP implementation. 
+ */
+void pj_rtp_seq_restart(pj_rtp_seq_session *seq_ctrl, pj_uint16_t seq);
+
+/** 
+* \brief Internal.
+ * Internal function for sequence control, shared by RTCP implementation. 
+ */
+int  pj_rtp_seq_update(pj_rtp_seq_session *seq_ctrl, pj_uint16_t seq);
+
+/**
+ * @}
+ */
+
+PJ_END_DECL
+
+
+#endif	/* __PJMEDIA_RTP_H__ */
Index: pjproject/trunk/pjmedia/include/pjmedia/sdp.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/sdp.h	(revision 121)
+++ pjproject/trunk/pjmedia/include/pjmedia/sdp.h	(revision 121)
@@ -0,0 +1,332 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJSDP_SDP_H__
+#define __PJSDP_SDP_H__
+
+/**
+ * @defgroup PJSDP SDP Library
+ */
+/**
+ * @file sdp.h
+ * @brief SDP header file.
+ */
+/**
+ * @defgroup PJ_SDP_H SDP stack.
+ * @ingroup PJSDP
+ * @{
+ *
+ * This SDP module consists of SDP parser, SDP structure, and function to
+ * print back the structure as SDP message.
+ */
+
+#include <pj/types.h>
+
+PJ_BEGIN_DECL
+
+#define PJSDP_MAX_FMT	32
+#define PJSDP_MAX_ATTR	32
+#define PJSDP_MAX_MEDIA	16
+
+/**
+ * This enumeration describes the attribute type.
+ */
+typedef enum pjsdp_attr_type_e
+{
+    PJSDP_ATTR_RTPMAP,
+    PJSDP_ATTR_CAT,
+    PJSDP_ATTR_KEYWORDS,
+    PJSDP_ATTR_TOOL,
+    PJSDP_ATTR_PTIME,
+    PJSDP_ATTR_RECV_ONLY,
+    PJSDP_ATTR_SEND_ONLY,
+    PJSDP_ATTR_SEND_RECV,
+    PJSDP_ATTR_ORIENT,
+    PJSDP_ATTR_TYPE,
+    PJSDP_ATTR_CHARSET,
+    PJSDP_ATTR_SDP_LANG,
+    PJSDP_ATTR_LANG,
+    PJSDP_ATTR_FRAME_RATE,
+    PJSDP_ATTR_QUALITY,
+    PJSDP_ATTR_FMTP,
+    PJSDP_ATTR_INACTIVE,
+    PJSDP_ATTR_GENERIC,
+    PJSDP_END_OF_ATTR,
+} pjsdp_attr_type_e;
+
+
+/**
+ * This structure keeps the common attributes that all 'descendants' 
+ * will have.
+ */
+typedef struct pjsdp_attr
+{
+    pjsdp_attr_type_e	type;	/**< Attribute type. */
+} pjsdp_attr;
+
+
+/**
+ * This is the structure to represent generic attribute which has a 
+ * string value.
+ */
+typedef struct pjsdp_attr_string
+{
+    pjsdp_attr_type_e	type;
+    pj_str_t		value;
+} pjsdp_attr_string;
+
+
+/**
+ * This is the structure to represent generic SDP attribute which has
+ * a numeric value.
+ */
+typedef struct pjsdp_attr_num
+{
+    pjsdp_attr_type_e	type;
+    pj_uint32_t		value;
+} pjsdp_attr_num;
+
+
+/**
+ * SDP \a rtpmap attribute.
+ */
+typedef struct pjsdp_rtpmap_attr
+{
+    pjsdp_attr_type_e	type;
+    unsigned		payload_type;
+    pj_str_t		encoding_name;
+    unsigned		clock_rate;
+    pj_str_t		parameter;
+} pjsdp_rtpmap_attr;
+
+
+/**
+ * SDP \a fmtp attribute.
+ */
+typedef struct pjsdp_fmtp_attr
+{
+    pjsdp_attr_type_e	type;
+    pj_str_t		format;
+    pj_str_t		param;
+} pjsdp_fmtp_attr;
+
+
+/** 
+ * SDP generic attribute.
+ */
+typedef struct pjsdp_generic_attr
+{
+    pjsdp_attr_type_e	type;
+    pj_str_t		name;
+    pj_str_t		value;
+} pjsdp_generic_attr;
+
+
+/** SDP \a cat attribute. */
+typedef struct pjsdp_attr_string pjsdp_cat_attr;
+
+/** SDP \a keywds attribute. */
+typedef struct pjsdp_attr_string pjsdp_keywds_attr;
+
+/** SDP \a tool attribute. */
+typedef struct pjsdp_attr_string pjsdp_tool_attr;
+
+/** SDP \a ptime attribute. */
+typedef struct pjsdp_attr_num pjsdp_ptime_attr;
+
+/** SDP \a recvonly attribute. */
+typedef struct pjsdp_attr pjsdp_recv_only_attr;
+
+/** SDP \a sendonly attribute. */
+typedef struct pjsdp_attr pjsdp_send_only_attr;
+
+/** SDP \a sendrecv attribute. */
+typedef struct pjsdp_attr pjsdp_send_recv_attr;
+
+/** SDP \a orient attribute. */
+typedef struct pjsdp_attr_string pjsdp_orient_attr;
+
+/** SDP \a type attribute. */
+typedef struct pjsdp_attr_string pjsdp_type_attr;
+
+/** SDP \a charset attribute. */
+typedef struct pjsdp_attr_string pjsdp_charset_attr;
+
+/** SDP \a sdplang attribute. */
+typedef struct pjsdp_attr_string pjsdp_sdp_lang_attr;
+
+/** SDP \a lang attribute. */
+typedef struct pjsdp_attr_string pjsdp_lang_attr;
+
+/** SDP \a framerate attribute. */
+typedef struct pjsdp_attr_string pjsdp_frame_rate_attr;
+
+/** SDP \a quality attribute. */
+typedef struct pjsdp_attr_num pjsdp_quality_attr;
+
+/** SDP \a inactive attribute. */
+typedef struct pjsdp_attr pjsdp_inactive_attr;
+
+/** Clone attribute */
+PJ_DECL(pjsdp_attr*) pjsdp_attr_clone (pj_pool_t *pool, const pjsdp_attr *rhs);
+
+/** Find attribute */
+PJ_DECL(const pjsdp_attr*) pjsdp_attr_find (int count, const pjsdp_attr *attr_array[], int type);
+
+/**
+ * SDP connection info.
+ */
+typedef struct pjsdp_conn_info
+{
+    pj_str_t	net_type;
+    pj_str_t	addr_type;
+    pj_str_t	addr;
+} pjsdp_conn_info;
+
+/** 
+ *Clone connection info. 
+ * 
+ * @param pool	    Pool to allocate memory for the new connection info.
+ * @param rhs	    The connection into to clone.
+ *
+ * @return the new connection info.
+ */
+PJ_DECL(pjsdp_conn_info*) pjsdp_conn_info_clone (pj_pool_t *pool, 
+						 const pjsdp_conn_info *rhs);
+
+/**
+ * SDP media description.
+ */
+typedef struct pjsdp_media_desc
+{
+    struct
+    {
+	pj_str_t    media;
+	pj_uint16_t port;
+	unsigned    port_count;
+	pj_str_t    transport;
+	unsigned    fmt_count;
+	pj_str_t    fmt[PJSDP_MAX_FMT];
+    } desc;
+
+    pjsdp_conn_info *conn;
+    unsigned	    attr_count;
+    pjsdp_attr	   *attr[PJSDP_MAX_ATTR];
+
+} pjsdp_media_desc;
+
+/** 
+ * Clone SDP media description. 
+ *
+ * @param pool	    Pool to allocate memory for the new media description.
+ * @param rhs	    The media descriptin to clone.
+ *
+ * @return a new media description.
+ */
+PJ_DECL(pjsdp_media_desc*) pjsdp_media_desc_clone (pj_pool_t *pool, 
+						   const pjsdp_media_desc *rhs);
+
+/** 
+ * Check if the media description has the specified attribute.
+ *
+ * @param m		The SDP media description.
+ * @param attr_type	The attribute type.
+ *
+ * @return nonzero if true.
+ */
+PJ_DECL(pj_bool_t) pjsdp_media_desc_has_attr (const pjsdp_media_desc *m, 
+					      pjsdp_attr_type_e attr_type);
+
+/** 
+ * Find rtpmap attribute for the specified payload type. 
+ *
+ * @param m	    The SDP media description.
+ * @param pt	    RTP payload type.
+ *
+ * @return the SDP rtpmap attribute for the payload type, or NULL if not found.
+ */
+PJ_DECL(const pjsdp_rtpmap_attr*) 
+pjsdp_media_desc_find_rtpmap (const pjsdp_media_desc *m, unsigned pt);
+
+
+/**
+ * This structure describes SDP session description.
+ */
+typedef struct pjsdp_session_desc
+{
+    struct
+    {
+	pj_str_t    user;
+	pj_uint32_t id;
+	pj_uint32_t version;
+	pj_str_t    net_type;
+	pj_str_t    addr_type;
+	pj_str_t    addr;
+    } origin;
+
+    pj_str_t	     name;
+    pjsdp_conn_info *conn;
+    
+    struct
+    {
+	pj_uint32_t start;
+	pj_uint32_t stop;
+    } time;
+
+    unsigned	    attr_count;
+    pjsdp_attr	   *attr[PJSDP_MAX_ATTR];
+
+    unsigned	      media_count;
+    pjsdp_media_desc *media[PJSDP_MAX_MEDIA];
+
+} pjsdp_session_desc;
+
+
+/**
+ * Parse SDP message.
+ *
+ * @param buf	    The message buffer.
+ * @param len	    The length of the message.
+ * @param pool	    The pool to allocate SDP session description.
+ *
+ * @return SDP session description.
+ */
+PJ_DECL(pjsdp_session_desc*) pjsdp_parse( char *buf, pj_size_t len, 
+					  pj_pool_t *pool);
+
+/**
+ * Print SDP description to a buffer.
+ *
+ * @param buf	    The buffer.
+ * @param size	    The buffer length.
+ * @param desc	    The SDP session description.
+ *
+ * @return the length printed, or -1.
+ */
+PJ_DECL(int) pjsdp_print( const pjsdp_session_desc *desc, 
+			  char *buf, pj_size_t size);
+
+
+/**
+ * @}
+ */
+
+PJ_END_DECL
+
+#endif	/* __PJSDP_SDP_H__ */
+
Index: pjproject/trunk/pjmedia/include/pjmedia/session.h
===================================================================
--- pjproject/trunk/pjmedia/include/pjmedia/session.h	(revision 121)
+++ pjproject/trunk/pjmedia/include/pjmedia/session.h	(revision 121)
@@ -0,0 +1,152 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#ifndef __PJMEDIA_SESSION_H__
+#define __PJMEDIA_SESSION_H__
+
+
+/**
+ * @file session.h
+ * @brief Media Session.
+ */
+
+#include <pj/types.h>
+#include <pjmedia/mediamgr.h>
+#include <pjmedia/stream.h>
+#include <pjmedia/sdp.h>
+
+PJ_BEGIN_DECL 
+
+/**
+ * @defgroup PJMED_SES Media session
+ * @ingroup PJMEDIA
+ * @{
+ */
+
+/** Opaque declaration of media session. */
+typedef struct pj_media_session_t pj_media_session_t;
+
+/** Media socket info. */
+typedef struct pj_media_sock_info
+{
+    pj_sock_t	    rtp_sock, rtcp_sock;
+    pj_sockaddr_in  rtp_addr_name;
+} pj_media_sock_info;
+
+/** Stream info. */
+typedef struct pj_media_stream_info
+{
+    pj_str_t		type;
+    pj_media_dir_t	dir;
+    pj_str_t		transport;
+    pj_media_sock_info	sock_info;
+    pj_str_t		rem_addr;
+    unsigned short	rem_port;
+    unsigned		fmt_cnt;
+    pj_codec_id		fmt[PJSDP_MAX_FMT];
+
+} pj_media_stream_info;
+
+/** Flag for modifying stream. */
+enum
+{
+    PJ_MEDIA_STREAM_MODIFY_DIR = 1,
+};
+
+/**
+ * Create new session offering.
+ */
+PJ_DECL(pj_media_session_t*) 
+pj_media_session_create ( pj_med_mgr_t *mgr, const pj_media_sock_info *skinfo );
+
+/**
+ * Create new session based on peer's offering.
+ */
+PJ_DECL(pj_media_session_t*) 
+pj_media_session_create_from_sdp ( pj_med_mgr_t *mgr, const pjsdp_session_desc *sdp,
+				   const pj_media_sock_info *skinfo);
+
+/**
+ * Duplicate session. The new session is inactive.
+ */
+PJ_DECL(pj_media_session_t*)
+pj_media_session_clone (const pj_media_session_t *session);
+
+/**
+ * Create SDP description from the session.
+ */
+PJ_DECL(pjsdp_session_desc*)
+pj_media_session_create_sdp ( const pj_media_session_t *session, pj_pool_t *pool,
+			      pj_bool_t only_first_fmt);
+
+/**
+ * Update session with SDP answer from peer. The session must NOT active.
+ */
+PJ_DECL(pj_status_t)
+pj_media_session_update ( pj_media_session_t *session, 
+			  const pjsdp_session_desc *sdp);
+
+/**
+ * Enumerate media streams in the session.
+ * @return the actual number of streams.
+ */
+PJ_DECL(unsigned)
+pj_media_session_enum_streams (const pj_media_session_t *session, 
+			       unsigned count, const pj_media_stream_info *info[]);
+
+/**
+ * Get stream statistics.
+ */
+PJ_DECL(pj_status_t)
+pj_media_session_get_stat (const pj_media_session_t *session, unsigned index,
+			   pj_media_stream_stat *tx_stat,
+			   pj_media_stream_stat *rx_stat);
+
+/**
+ * Modify stream, only when stream is inactive.
+ */
+PJ_DECL(pj_status_t)
+pj_media_session_modify_stream (pj_media_session_t *session, unsigned index,
+				unsigned modify_flag, const pj_media_stream_info *info);
+
+/**
+ * Activate all streams in media session.
+ */
+PJ_DECL(pj_status_t)
+pj_media_session_activate (pj_media_session_t *session);
+
+/**
+ * Activate individual stream in media session.
+ */
+PJ_DECL(pj_status_t)
+pj_media_session_activate_stream (pj_media_session_t *session, unsigned index);
+
+/**
+ * Destroy media session.
+ */
+PJ_DECL(pj_status_t)
+pj_media_session_destroy (pj_media_session_t *session);
+
+
+/**
+ * @}
+ */
+
+PJ_END_DECL
+
+#endif	/* __PJMEDIA_SESSION_H__ */
